require 'net/http'

module Consul
  class Http
    attr_accessor :http_client

    def initialize
      load_config
    end

    def request(method, uri, data=nil)
      response = http_client.send_request(method, ("/v1" + uri), data)
      Response.new(response, uri.gsub(%r{^/kv/}, ''))
    end

    def put(path, data=nil)
      request('PUT', path, data)
    end

    def get(path)
      request('GET', path)
    end

    def delete(path)
      request('DELETE', path)
    end

    def load_config
      self.http_client = Net::HTTP.new(Consul::Client.config.host, Consul::Client.config.port, nil, nil)
    end
  end
end
